
/*
 * Examples of gnuplot_i.c usage
 */

#include <stdio.h>
#include <stdlib.h>

#include "gnuplot_i.h"

#define SLEEP_LGTH  505		//2
#define SLEEP		Sleep(SLEEP_LGTH);
#define NPOINTS     50



#include <windows.h>				   ///roland
//#define sleep		Sleep			   ///roland
#define sleep(x)		 _getch()

#include <conio.h>					   ///roland - getch() function
	


#include <math.h>




int main(int argc, char *argv[]) 
{
    gnuplot_ctrl    *   h1,
                    *   h2,
                    *   h3,
                    *   h4;
    double              x[NPOINTS * 2];
    double              y[NPOINTS * 2];
    
    double				z[NPOINTS * NPOINTS * 4];
    
    int                 i, j;


    #define NX  NPOINTS
	#define NY  (NPOINTS * 2)


	typedef double		z2_T[NX][NY];

    z2_T				&z2 = *(z2_T *)z;

	
	


    /*
     * Initialize the gnuplot handle
     */
    printf("*** example of gnuplot control through C ***\n") ;
    h1 = gnuplot_init() ;
    
    if (!h1)				
		goto endmain1;				///roland
    
    
    
    
    
    
    //gnuplot_plot_x(h1, x, NPOINTS, "user-defined doubles") ;
    //sleep(SLEEP_LGTH) ;
    
    
    


	//printf("*** user-defined lists of points\n");

/*
	for (j = 0; j < NY; j++)
	{		
		for (i = 0; i < NX; i++) 
		{
			double xv = i;
			double yv = j;
		
			xv = xv / NX * 10;
			yv = yv / NY * 10;
		
			x[i] = xv;
			y[j] = yv;
			z2[i][j] = sin(xv) * cos(yv);
		}
	}

    gnuplot_resetplot(h1) ;
    gnuplot_setstyle(h1, "lines") ;
    //gnuplot_plot_xy(h1, x, y, NPOINTS, "user-defined points") ;
    gnuplot_splot_grid(h1, z, NX, NY, "3D chart") ;



	_getch();



	for (j = 0; j < NY; j++)
	{		
		for (i = 0; i < NX; i++) 
		{
			double xv = i;
			double yv = j;
		
			xv = xv / NX * 10;
			yv = yv / NY * 10;
		
			x[i] = xv;
			y[j] = yv;
			z2[i][j] = xv * yv;
		}
	}

    //gnuplot_resetplot(h1) ;
    gnuplot_setstyle(h1, "lines") ;
    //gnuplot_plot_xy(h1, x, y, NPOINTS, "user-defined points") ;
    gnuplot_splot_grid(h1, z, NX, NY, "3D chart2") ;
*/







	//Sleep(SLEEP_LGTH);
	//_getch();


    for (i=0 ; i<NPOINTS ; i++) {
        x[i] = (double)i ;
        y[i] = (double)i * (double)i ;
    }
    //gnuplot_resetplot(h1) ;
    gnuplot_setstyle(h1, "lines") ;
    gnuplot_plot_xy(h1, x, y, NPOINTS, "user-defined points2") ;


	SLEEP;


    for (i=0 ; i<NPOINTS ; i++) {
        x[i] = (double)i ;
        y[i] = (double)i + (double)i ;
    }
    //gnuplot_resetplot(h1) ;
    gnuplot_setstyle(h1, "lines") ;
    gnuplot_plot_xy(h1, x, y, NPOINTS, "user-defined points2") ;


	
	
	goto endmain2;    
    
    
    

    /*
     * Slopes
     */
    gnuplot_setstyle(h1, "lines") ;
    
    printf("*** plotting slopes\n") ;
    printf("y = x\n") ;
    gnuplot_plot_slope(h1, 1.0, 0.0, "unity slope") ;
    sleep(SLEEP_LGTH) ;

    printf("y = 2*x\n") ;
    gnuplot_plot_slope(h1, 2.0, 0.0, "y=2x") ;
    sleep(SLEEP_LGTH) ;

    printf("y = -x\n") ;
    gnuplot_plot_slope(h1, -1.0, 0.0, "y=-x") ;
    sleep(SLEEP_LGTH) ;
    

    /*
     * Equations
     */

    gnuplot_resetplot(h1) ;
    printf("\n\n") ;
    printf("*** various equations\n") ;
    printf("y = sin(x)\n") ;
    gnuplot_plot_equation(h1, "sin(x)", "sine") ;
    sleep(SLEEP_LGTH) ;

    printf("y = log(x)\n") ;
    gnuplot_plot_equation(h1, "log(x)", "logarithm") ;
    sleep(SLEEP_LGTH) ;

    printf("y = sin(x)*cos(2*x)\n") ;
    gnuplot_plot_equation(h1, "sin(x)*cos(2*x)", "sine product") ;
    sleep(SLEEP_LGTH) ;


    /*
     * Styles
     */

    gnuplot_resetplot(h1) ;
    printf("\n\n") ;
    printf("*** showing styles\n") ;

    printf("sine in points\n") ;
    gnuplot_setstyle(h1, "points") ;
    gnuplot_plot_equation(h1, "sin(x)", "sine") ;
    sleep(SLEEP_LGTH) ;
    
    printf("sine in impulses\n") ;
    gnuplot_setstyle(h1, "impulses") ;
    gnuplot_plot_equation(h1, "sin(x)", "sine") ;
    sleep(SLEEP_LGTH) ;
    
    printf("sine in steps\n") ;
    gnuplot_setstyle(h1, "steps") ;
    gnuplot_plot_equation(h1, "sin(x)", "sine") ;
    sleep(SLEEP_LGTH) ;

    /*
     * User defined 1d and 2d point sets
     */

    gnuplot_resetplot(h1) ;
    gnuplot_setstyle(h1, "impulses") ;
    printf("\n\n") ;
    printf("*** user-defined lists of doubles\n") ;
    for (i=0 ; i<NPOINTS ; i++) {
        x[i] = (double)i*i ;
    }
    gnuplot_plot_x(h1, x, NPOINTS, "user-defined doubles") ;
    sleep(SLEEP_LGTH) ;

	printf("*** user-defined lists of points\n");
    for (i=0 ; i<NPOINTS ; i++) {
        x[i] = (double)i ;
        y[i] = (double)i * (double)i ;
    }
    gnuplot_resetplot(h1) ;
    gnuplot_setstyle(h1, "points") ;
    gnuplot_plot_xy(h1, x, y, NPOINTS, "user-defined points") ;
    sleep(SLEEP_LGTH) ;



    /*
     * Multiple output screens
     */

#if 0

    printf("\n\n") ;
    printf("*** multiple output windows\n") ;
    gnuplot_resetplot(h1) ;
    gnuplot_setstyle(h1, "lines") ;
    h2 = gnuplot_init() ;
    gnuplot_setstyle(h2, "lines") ;
    h3 = gnuplot_init() ;
    gnuplot_setstyle(h3, "lines") ;
    h4 = gnuplot_init() ;
    gnuplot_setstyle(h4, "lines") ;

    printf("window 1: sin(x)\n") ;
    gnuplot_plot_equation(h1, "sin(x)", "sin(x)") ;
    sleep(SLEEP_LGTH) ;
    printf("window 2: x*sin(x)\n") ;
    gnuplot_plot_equation(h2, "x*sin(x)", "x*sin(x)") ;
    sleep(SLEEP_LGTH) ;
    printf("window 3: log(x)/x\n") ;
    gnuplot_plot_equation(h3, "log(x)/x", "log(x)/x");
    sleep(SLEEP_LGTH) ;
    printf("window 4: sin(x)/x\n") ;
    gnuplot_plot_equation(h4, "sin(x)/x", "sin(x)/x") ;
    sleep(SLEEP_LGTH) ;
    

    
    /*
     * close gnuplot handles
     */
     
     
endmain2:;     
    _getch();									  ///roland
     


    printf("\n\n") ;
    printf("*** end of gnuplot example\n") ;
    gnuplot_close(h1) ;
    gnuplot_close(h2) ;
    gnuplot_close(h3) ;
    gnuplot_close(h4) ;
    
#else


endmain2:;
	_getch();

    //gnuplot_close(h1) ;    
    
#endif     
    
    goto endmain;
    
    
    
endmain1:;							  ///roland

	_getch();						   ///roland
	

endmain:;							  ///roland
    
    
    return 0 ;
}
